////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// F A R M     -  Flair advanced rendering module
//
// Copyright European Organization for Nuclear Research( CERN )
// All rights reserved
//
// Authors: Christian.Theis@cern.ch
//			    Vasilis.Vlachoudis@cern.ch
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "bxdfminnaert.h"


CBxDFMinnaert::CBxDFMinnaert(void) : CBxDFBase( CBxDFBase::BSDF_DIFFUSE )
{
}

CBxDFMinnaert::~CBxDFMinnaert(void)
{
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////

double CBxDFMinnaert::f( const Ray& Out, const Ray& In, const Vector& Normal, const Material& RenderMat, const Color& LightColor, double Power, float Shade /*= 1.0*/ )

////////////////////////////////////////////////////////////////////////////////////////////////////////////
{
  UNUSED( LightColor ); UNUSED( Power ); UNUSED( Shade );

  double  ResColor;
  Vector L = In.dir();        // light vector


  // calculate diffuse shading
  double CosTIn = L.dot( Normal );
  if( CosTIn <= 0.f)
    return 0.0;

  double CosTOut = -Out.dir().dot( Normal );
  if( CosTOut <= 0.0)
    CosTOut = 0.0;

  double Diff = (double)( RenderMat.specular() );
  // add diffuse component to ray color
  // TODO: Check the formula for the effect of K!
  double K = 0.5;
  ResColor = Diff * ( K + 1.0 ) * 0.5 * pow( std::max( CosTIn * CosTOut, 0.1 ), K - 1.0 ) / PI;

  return ResColor;
}
// vim:ts=2
